#include "zmult.h"

#define alpha24 zmult_alpha24
#define alpha48 zmult_alpha48
#define twom48 zmult_twom48
#define reg register double

void zmult_1(double out[2],double u[1],double v[1],double tmp[0])
{
  reg t0, t1, t2, t3, t4, t5, t6, t7;

  t0 = u[0];
  t1 = alpha24;
  t1 += t0;
  t4 = v[0];
  t5 = alpha24;
  t5 += t4;
  t1 -= alpha24;

  t5 -= alpha24;
  t0 -= t1;
  t3 = t1;
  t4 -= t5;
  t2 = t0;
  t2 *= t5; t7 = alpha48;

  t3 *= t4;

  t0 *= t4;

  t1 *= t5;
  t2 += t3;


  t7 += t2;


  t7 -= alpha48;


  t1 += t7;
  t2 -= t7;

  t1 *= twom48;
  out[1] = t1;
  t0 += t2;
  out[0] = t0;
}

void zmult_2(double out[4],double u[2],double v[2],double tmp[4])
{
  reg t0, t1, t2, t3, t4, t5, t6, t7;
  t4 = u[0];
  t5 = alpha24;
  t5 += t4;
  t5 -= alpha24;
  t4 -= t5;
  t6 = v[0];
  t7 = alpha24;
  t7 += t6;
  t7 -= alpha24;
  t6 -= t7;
  t2 = u[1];
  t3 = alpha24;
  t3 += t2;
  t3 -= alpha24;
  tmp[1] = t3;
  t2 -= t3;
  tmp[0] = t2;
  t2 = v[1];
  t3 = alpha24;
  t3 += t2;
  t3 -= alpha24;
  tmp[3] = t3;
  t2 -= t3;
  tmp[2] = t2;

  t1 = t4;
  t1 *= t6;
  t2 = t4;
  t2 *= t7;
  t0 = t5;
  t0 *= t6;
  t2 += t0;
  t0 = alpha48;
  t0 += t2;
  t0 -= alpha48;
  t2 -= t0;
  t1 += t2;
  out[0] = t1;

  t3 = t5;
  t3 *= t7;
  t3 *= twom48;
  t2 = tmp[2];
  t2 *= t4;
  t3 += t2;
  t1 = tmp[0];
  t1 *= t6;
  t3 += t1;
  t4 *= tmp[3];
  t6 *= tmp[1];
  t2 = tmp[2];
  t2 *= t5;
  t4 += t2;
  t1 = tmp[0];
  t1 *= t7;
  t6 += t1;
  t4 += t6;
  t2 = alpha48;
  t2 += t4;
  t2 -= alpha48;
  t1 = twom48;
  t0 *= t1;
  t4 -= t2;
  t3 += t4;
  t3 += t0;
  out[1] = t3;

  t4 = tmp[3];
  t5 *= t4;
  t7 *= tmp[1];
  t5 += t7;
  t5 *= t1;
  t0 = tmp[0];
  t0 *= tmp[2];
  t5 += t0;
  t6 = tmp[0];
  t6 *= t4;
  t0 = tmp[1];
  t0 *= tmp[2];
  t6 += t0;
  t2 *= t1;
  t3 = alpha48;
  t3 += t6;
  t3 -= alpha48;
  t6 -= t3;
  t5 += t6;
  t5 += t2;
  out[2] = t5;
  
  t4 *= tmp[1];
  t4 += t3;
  t4 *= t1;
  out[3] = t4;
}

void zmult_4(double out[8],double u[4],double v[4],double tmp[16])
{
  reg t0, t1, t2, t3, t4, t5, t6, t7;

  t5 = alpha24; t4 = u[0]; t5 += t4; t5 -= alpha24; tmp[1] = t5;
  t4 -= t5; tmp[0] = t4;
  t7 = alpha24; t6 = v[0]; t7 += t6; t7 -= alpha24; tmp[9] = t7;
  t6 -= t7; tmp[8] = t6;

  t7 = alpha24; t6 = u[1]; t7 += t6; t7 -= alpha24; tmp[3] = t7;
  t6 -= t7; tmp[2] = t6;
  t7 = alpha24; t6 = v[1]; t7 += t6; t7 -= alpha24; tmp[11] = t7;
  t6 -= t7; tmp[10] = t6;
  t7 = alpha24; t6 = u[2]; t7 += t6; t7 -= alpha24; tmp[5] = t7;
  t6 -= t7; tmp[4] = t6;
  t7 = alpha24; t6 = v[2]; t7 += t6; t7 -= alpha24; tmp[13] = t7;
  t6 -= t7; tmp[12] = t6;
  t7 = alpha24; t6 = u[3]; t7 += t6; t7 -= alpha24; tmp[7] = t7;
  t6 -= t7; tmp[6] = t6;
  t7 = alpha24; t6 = v[3]; t7 += t6; t7 -= alpha24; tmp[15] = t7;
  t6 -= t7; tmp[14] = t6;

  t0 = tmp[0];
  t0 *= tmp[8];
  t1 = tmp[0];
  t1 *= tmp[9];
  t3 = tmp[1];
  t3 *= tmp[8];
  t1 += t3;
  t2 = alpha48; t2 += t1;
  t7 = alpha48; t2 -= t7; t1 -= t2; t0 += t1; out[0] = t0;

  t4 = tmp[1];
  t4 *= tmp[9];
  t2 += t4;
  t2 *= twom48;
  t0 = tmp[0];
  t0 *= tmp[10];
  t0 += t2;
  t5 = tmp[2];
  t5 *= tmp[8];
  t0 += t5;
  t1 = tmp[0];
  t1 *= tmp[11];
  t6 = tmp[1];
  t6 *= tmp[10];
  t1 += t6;
  t3 = tmp[2];
  t3 *= tmp[9];
  t1 += t3;
  t4 = tmp[3];
  t4 *= tmp[8];
  t1 += t4;
  t2 = t7; t2 += t1; t2 -= t7; t1 -= t2; t0 += t1; out[1] = t0;

  t5 = tmp[1];
  t5 *= tmp[11];
  t2 += t5;
  t6 = tmp[3];
  t6 *= tmp[9];
  t2 += t6;
  t2 *= twom48;
  t0 = tmp[0];
  t0 *= tmp[12];
  t3 = tmp[2];
  t3 *= tmp[10];
  t0 += t3;
  t4 = tmp[4];
  t4 *= tmp[8];
  t0 += t4;
  t0 += t2;
  t1 = tmp[0];
  t1 *= tmp[13];
  t5 = tmp[1];
  t5 *= tmp[12];
  t1 += t5;
  t6 = tmp[2];
  t6 *= tmp[11];
  t1 += t6;
  t3 = tmp[3];
  t3 *= tmp[10];
  t1 += t3;
  t4 = tmp[4];
  t4 *= tmp[9];
  t1 += t4;
  t5 = tmp[5];
  t5 *= tmp[8];
  t1 += t5;
  t2 = t7; t2 += t1; t2 -= t7; t1 -= t2; t0 += t1; out[2] = t0;

  t6 = tmp[1];
  t6 *= tmp[13];
  t2 += t6;
  t3 = tmp[3];
  t3 *= tmp[11];
  t2 += t3;
  t4 = tmp[5];
  t4 *= tmp[9];
  t2 += t4;
  t2 *= twom48;
  t0 = tmp[0];
  t0 *= tmp[14];
  t5 = tmp[2];
  t5 *= tmp[12];
  t0 += t5;
  t6 = tmp[4];
  t6 *= tmp[10];
  t0 += t6;
  t3 = tmp[6];
  t3 *= tmp[8];
  t0 += t3;
  t0 += t2;
  t1 = tmp[0];
  t1 *= tmp[15];
  t4 = tmp[1];
  t4 *= tmp[14];
  t1 += t4;
  t5 = tmp[2];
  t5 *= tmp[13];
  t1 += t5;
  t6 = tmp[3];
  t6 *= tmp[12];
  t1 += t6;
  t3 = tmp[4];
  t3 *= tmp[11];
  t1 += t3;
  t4 = tmp[5];
  t4 *= tmp[10];
  t1 += t4;
  t5 = tmp[6];
  t5 *= tmp[9];
  t1 += t5;
  t6 = tmp[7];
  t6 *= tmp[8];
  t1 += t6;
  t2 = t7; t2 += t1; t2 -= t7; t1 -= t2; t0 += t1; out[3] = t0;

  t3 = tmp[1];
  t3 *= tmp[15];
  t2 += t3;
  t4 = tmp[3];
  t4 *= tmp[13];
  t2 += t4;
  t5 = tmp[5];
  t5 *= tmp[11];
  t2 += t5;
  t6 = tmp[7];
  t6 *= tmp[9];
  t2 += t6;
  t2 *= twom48;
  t0 = tmp[2];
  t0 *= tmp[14];
  t3 = tmp[4];
  t3 *= tmp[12];
  t0 += t3;
  t4 = tmp[6];
  t4 *= tmp[10];
  t0 += t4;
  t0 += t2;
  t1 = tmp[2];
  t1 *= tmp[15];
  t5 = tmp[3];
  t5 *= tmp[14];
  t1 += t5;
  t6 = tmp[4];
  t6 *= tmp[13];
  t1 += t6;
  t3 = tmp[5];
  t3 *= tmp[12];
  t1 += t3;
  t4 = tmp[6];
  t4 *= tmp[11];
  t1 += t4;
  t5 = tmp[7];
  t5 *= tmp[10];
  t1 += t5;
  t2 = t7; t2 += t1; t2 -= t7; t1 -= t2; t0 += t1; out[4] = t0;

  t6 = tmp[3];
  t6 *= tmp[15];
  t2 += t6;
  t3 = tmp[5];
  t3 *= tmp[13];
  t2 += t3;
  t4 = tmp[7];
  t4 *= tmp[11];
  t2 += t4;
  t2 *= twom48;
  t0 = tmp[4];
  t0 *= tmp[14];
  t5 = tmp[6];
  t5 *= tmp[12];
  t0 += t5;
  t0 += t2;
  t1 = tmp[4];
  t1 *= tmp[15];
  t6 = tmp[5];
  t6 *= tmp[14];
  t1 += t6;
  t3 = tmp[6];
  t3 *= tmp[13];
  t1 += t3;
  t4 = tmp[7];
  t4 *= tmp[12];
  t1 += t4;
  t2 = t7; t2 += t1; t2 -= t7; t1 -= t2; t0 += t1; out[5] = t0;

  t4 = tmp[7];
  t4 *= tmp[15];
  t1 = tmp[6];
  t1 *= tmp[15];
  t3 = tmp[7];
  t3 *= tmp[14];
  t1 += t3;

  t5 = tmp[5];
  t5 *= tmp[15];
  t2 += t5;
  t6 = tmp[7];
  t6 *= tmp[13];
  t2 += t6;
  t2 *= twom48;
  t0 = tmp[6];
  t0 *= tmp[14];
  t0 += t2;
  t2 = t7; t2 += t1; t2 -= t7; t1 -= t2; t0 += t1; out[6] = t0;

  t2 += t4;
  t2 *= twom48;
  out[7] = t2;
}
